
Imports System
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Web.Security

    Namespace myPassportWeb
 
        Public class myPassportIdentity : 
            Inherits System.Web.UI.Page

            Public UserName as Label
            Public UserPUID as Label 
            Public StatusLabel as Label
            Public AuthenticationLabel as Label
            Public ElapsedTimeSignIn as Label
            Public ElapsedTimeTicket as Label
            Public SavedPassword as Label
            Public Nickname as Label
            Public HaveConsentLabel as Label
            Public IsAuthenticatedLabel as Label
            Public UrlLabel as Label
            Public Message as Label
            Public HasTicket as Label
            Public ErrorState as Label
            Public EncryptedText as Label
            Public DecryptedText as Label

            Public passportlink as System.Web.UI.HtmlControls.HtmlGenericControl
 

            Public Sub myPassportIdentity()
                AddHandler Me.Load, AddressOf Page_Load
            End Sub            

            Public Sub Page_Load(Sender as Object, e as System.EventArgs)

	            Dim NewPass As new System.Web.Security.PassportIdentity()

                Dim MyURL as string = NewPass.AuthUrl()

                StatusLabel.Text = NewPass.IsAuthenticated.ToString()
                
                ' Tests whether the user has a valid Passport ticket on their query string
                HasTicket.Text = NewPass.HasTicket.ToString()               
        
                ' Sets the URL for passportLink = the URL of the appropriate Passport SignIn/SignOut Authority and diplays the logo.
                passportlink.InnerHtml=NewPass.LogoTag()

		UrlLabel.Text = "&nbsp;" & MyURL

                ' Set MemberName variable = Passport member name from their cookie
                Dim MemberName as string = NewPass.Name

                If (MemberName.Length > 0) Then

                    UserName.Text = MemberName

                    ' Get the name of the Passport domain associated with the current UserName
                    Dim PassportDomain as string = NewPass.GetDomainFromMemberName(NewPass.Name)

                    ' Get the URL for the Passport Information page using the GetDomainAttribute(attributeName, LocaleID, Domain) method
                    Dim InfoURL as string = NewPass.GetDomainAttribute("PassportInformationCenter", 1033, PassportDomain) ' LocaleID 1033 = English-USA

                    ' Get the error information associated with the current Passport ticket 
                    Select Case (NewPass.Error) ' Display the appropriate error description for each error code
                        Case 0
                            ErrorState.Text = "No Errors." 
                	Case 1, 2, 3, 8, 9
                            ErrorState.Text = "A network error has prevented your Passport sign-in. Please try again."
                        Case 4
                            ErrorState.Text = "Your Passport account has been locked. Please contact <a href='" & InfoURL & "'>Passport  Member Services</a>."
                        Case 5
                            ErrorState.Text = "Your Passport core profile is unavailable. Please contact <a HREF='" & InfoURL & "'>Passport  Member Services</a>."
                        Case 6
                            ErrorState.Text = "The Passport server you tried to reach  is unavailable."
                        Case 7  'Member's ticket or profile was in old key.
                            ErrorState.Text = "Your Passport profile is out of date, and you should sign in again. Click Sign Out and then return to this site and sign in again."
                        Case 10 'A site tried to use KPP features without authorization
                            ErrorState.Text = "This site does not support KIDS Passport validation properly."
                        Case Else
                            ErrorState.Text = "unavailable."
                    End Select
                End If
                  
                      
                ' Test whether user is authenticated with Passport Authority
	            If (NewPass.IsAuthenticated = true) Then
                    
                    ' Tests whether the user profile attribute exists and if so retrieves the value
                    If NewPass.HasProfile("MemberIDHigh") = true Then
                        ' Set UserPUID label = Passport User's PUID unique identifier            
                        UserPUID.Text = NewPass.GetProfileObject("MemberIDHigh").ToString() & _
                                        NewPass.GetProfileObject("MemberIDLow").ToString()
                    Else
                        UserPUID.Text = "unavailable"
                    End If
                    
                    Nickname.Text = "Nickname: " & NewPass.GetProfileObject("Nickname").ToString()
                    
                    AuthenticationLabel.Text = "Authentication Type: " & NewPass.AuthenticationType.ToString()
                    
                    Dim TimeWindow as Integer = 1
                    Dim ForceLogin as Boolean = true
                    Dim CheckSecure as Boolean = true
                          
                    IsAuthenticatedLabel.Text = "GetIsAuthenticated: " & _
                                        NewPass.GetIsAuthenticated(TimeWindow, ForceLogin, CheckSecure).ToString()

                    ' Returns the elapsed time since the user last signed in with the Passport Authority.
                    ElapsedTimeSignIn.Text = "Elapsed time since SignIn: " & NewPass.TimeSinceSignIn.ToString() & " seconds."             
                
                    ' Returns the elapsed time since the user's ticket was last refreshed with the Passport Authority.
                    ElapsedTimeTicket.Text = "Elapsed time since ticket refresh: " & NewPass.TicketAge.ToString() & " seconds."
                                   
                Else
                       
                    ' Resets labels when not signed in
                    UserName.Text = "unavailable" 
                    UserPUID.Text = "unavailable"
                    AuthenticationLabel.Text = "&nbsp"
                    Nickname.Text = "&nbsp"
                    HaveConsentLabel.Text = "&nbsp"
                    IsAuthenticatedLabel.Text = "&nbsp" 
                    ' Set StatusLabel = the URL of the Passport SignIn page
                            
                End If
                	        	
            End Sub


        End Class

    End Namespace
