
using System;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Web.Security;

namespace myPassportWeb
{ 

public class myPassportIdentity : System.Web.UI.Page
   {
    protected System.Web.UI.WebControls.Label UserName;
    protected System.Web.UI.WebControls.Label UserPUID;
    protected System.Web.UI.WebControls.Label StatusLabel;
    protected System.Web.UI.WebControls.Label ServerConnection;
    protected System.Web.UI.WebControls.Label SavedPassword;
    protected System.Web.UI.WebControls.Label Greeting;
    protected System.Web.UI.WebControls.Label UrlLabel;
    protected System.Web.UI.HtmlControls.HtmlGenericControl passportlink;
    protected System.Web.UI.WebControls.TextBox TextBox1;
    protected System.Web.UI.WebControls.Button Update;
    protected System.Web.UI.WebControls.Label Message;

    public myPassportIdentity() {
        Page.Init += new System.EventHandler(Page_Load); 
    }

    protected void Page_Load(object sender, System.EventArgs e){

        // Declare new PassportIdendity object as variable newPass
	System.Web.Security.PassportIdentity newPass = new System.Web.Security.PassportIdentity();

        // Declare and set myURL variable = the URL of the appropriate Passport SignIn/SignOut Authority
        string myURL = newPass.AuthUrl();

        // Set StatusLabel = the users SignIn status (a boolean) converted to a string
        StatusLabel.Text = newPass.IsAuthenticated.ToString();

        // Set ServerConnection label = the Passport server status (a boolean) converted to a string
        ServerConnection.Text = newPass.GetFromNetworkServer.ToString();

        // Tests whether the user has stored their password locally and displays this value in the SavedPassword label
        SavedPassword.Text = newPass.HasSavedPassword.ToString();

        // Sets the URL for passportLink = the URL of the appropriate Passport SignIn/SignOut Authority and diplays the logo.
        passportlink.InnerHtml=newPass.LogoTag();

	Greeting.Text = "Nickname: " + newPass.GetProfileObject("Nickname").ToString();

        // Test whether user is authenticated with Passport Authority
	if (newPass.IsAuthenticated == true) {

            // Set UserName label = Passport user name
            UserName.Text = newPass.Name; 

            // Set UserPUID label = Passport User's PUID unique identifier            
            UserPUID.Text = newPass.GetProfileObject("MemberIDHigh").ToString() + 
                            newPass.GetProfileObject("MemberIDLow").ToString();
            Greeting.Text = "Nickname: " + newPass.GetProfileObject("Nickname").ToString();

            // Set StatusLabel = the URL of the website homepage 
            UrlLabel.Text = "http://myHomepage.aspx";
           }
        else {

            // Resets UserName label
            UserName.Text = "unavailable"; 
            UserPUID.Text = "unavailable";
            Greeting.Text = "&nbsp;";
            // Set StatusLabel = the URL of the Passport SignIn page
            UrlLabel.Text = myURL ;        
           }
		
    }

    protected void Update_Click(Object sender, EventArgs e) {
	Object myProfile;
        Boolean updateResult = false;
        // Declare new PassportIdendity object as variable newPass
	System.Web.Security.PassportIdentity newPass = new System.Web.Security.PassportIdentity();

        // Test whether user is authenticated with Passport Authority
        if (newPass.IsAuthenticated == true) {
	    myProfile = newPass.GetProfileObject("Nickname");
            myProfile = TextBox1.Text;
	    //Updates the value of the user's Passport Nickname 
            newPass.SetProfileObject("Nickname", myProfile);
	    //Commits the changes to the user's Passport Profile
            updateResult = newPass.Commit();
	    if (updateResult == true) {
                Message.Text = "Your profile has been updated.";
                TextBox1.Text = "";   
               }
            else {
                Message.Text = "Profile update failed, changes were not saved.";
               }
           }
        else {
            Message.Text = "Please sign in to your Passport account.";
           }
    }

  } //End Class - myPassportIdentity
} //End NameSpace - myPassportWeb